{-
 *  Programmer:	Piotr Borek
 *  E-mail:     piotrborek@op.pl
 *  Copyright 2015 Piotr Borek
 *
 *  Distributed under the terms of the GPL (GNU Public License)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-}

module Coin.UI.Widgets.InputBox (
    inputBoxNew
) where

import Data.Maybe

import Graphics.UI.Gtk

import Coin.UI.Builder.GtkUIBuilder
import Coin.UI.Widgets.ResponseButtons

inputBoxNew :: String -> (Maybe String -> IO ()) -> IO ()
inputBoxNew msg fun = do
    responseButtons <- responseButtonsNew ButtonsOkCancel

    (getObject, root) <-uiBuildGtk $ do
        windowAttrs [ windowModal := True, windowTypeHint := WindowTypeHintDialog, windowResizable := False ]
        window Nothing "" $ do
            vbox Nothing False 0 $ do
                packing PackGrow 5
                hbox Nothing False 0 $ do
                    packing PackNatural 5
                    imageFromStock Nothing stockEdit IconSizeDialog
                    label Nothing msg
                    pack PackGrow 5 $ entry (Just "text") ""
                packDefault $ hseparator Nothing
                putWidget responseButtons

    responseButtonsOnActivated responseButtons $ \r -> do
        s <- entryGetText . castToEntry . fromJust $ getObject "text"
        widgetDestroy root
        if (r == ResponseOk && s /= "")
            then fun $ Just s
            else fun Nothing

    widgetShowAll root
